"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const BasketContext = React.createContext({
    items: [],
    onAllItemsDeleted: () => { },
    onItemAdded: (id) => { },
    onItemDeleted: (id) => { }
});
exports.BasketContext = BasketContext;
const withBasketData = (Wrap) => (props) => {
    return (React.createElement(BasketContext.Consumer, null, (basketData) => (React.createElement(Wrap, Object.assign({ basketData: basketData }, props)))));
};
exports.withBasketData = withBasketData;
