"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const __1 = require("../");
class BasketProvider extends React.Component {
    constructor(props) {
        super(props);
        this.onAllItemsAdded = () => {
            this.setState({ isLoading: true }, () => {
                this.props.dataProvider.onAllItemsDeleted()
                    .then(items => {
                    this.setState({ items, isLoading: false });
                });
            });
        };
        this.onItemAdded = (id) => {
            this.setState({ isLoading: true }, () => {
                this.props.dataProvider.onItemAdded(id)
                    .then(items => {
                    this.setState({ items, isLoading: false });
                });
            });
        };
        this.onItemDeleted = (id) => {
            this.setState({ isLoading: true }, () => {
                this.props.dataProvider.onItemDeleted(id)
                    .then(items => {
                    this.setState({ items, isLoading: false });
                });
            });
        };
        this.state = {
            isLoading: false,
            items: [],
            onAllItemsDeleted: this.onAllItemsAdded,
            onItemAdded: this.onItemAdded,
            onItemDeleted: this.onItemDeleted,
        };
    }
    componentWillMount() {
        this.props.dataProvider.registerToChanges((items) => {
            this.setState({ items });
        });
    }
    componentDidMount() {
        this.setState({ isLoading: true }, () => {
            this.props.dataProvider.getInitialData()
                .then(items => {
                this.setState({ items, isLoading: false });
            });
        });
    }
    render() {
        return (React.createElement(__1.BasketContext.Provider, { value: this.state }, this.props.children));
    }
}
exports.BasketProvider = BasketProvider;
