"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const material_table_1 = __importDefault(require("material-table"));
const DeleteOutline_1 = __importDefault(require("@material-ui/icons/DeleteOutline"));
const basket_context_1 = require("../basket-context");
class BasketInner extends React.Component {
    render() {
        return (React.createElement(core_1.Card, { elevation: 0 },
            React.createElement(core_1.CardContent, { style: { padding: 0 } },
                React.createElement(material_table_1.default, { components: {
                        Container: (props) => React.createElement(core_1.Paper, Object.assign({}, props, { elevation: 0 }))
                    }, isLoading: this.props.basketData.isLoading, title: "Shopping Cart", data: this.props.basketData.items, actions: [
                        {
                            icon: () => React.createElement(DeleteOutline_1.default, null),
                            tooltip: 'Delete Item(s)',
                            onClick: (e, rowData) => {
                                this.props.basketData.onItemDeleted(rowData.id);
                            }
                        },
                        {
                            icon: () => React.createElement(DeleteOutline_1.default, null),
                            tooltip: 'Delete All Item',
                            onClick: () => {
                                this.props.basketData.onAllItemsDeleted();
                            },
                            isFreeAction: true
                        }
                    ], columns: [
                        { title: 'Product', field: 'name' },
                        { title: 'Quantity', field: 'quantity', type: 'numeric' },
                        { title: 'Price', field: 'price', type: 'currency' },
                    ], options: {
                        actionsColumnIndex: -1,
                        emptyRowsWhenPaging: false,
                        paging: false,
                        search: false
                    }, localization: {
                        body: {
                            emptyDataSourceMessage: 'No item in your shopping cart'
                        },
                        header: {
                            actions: ''
                        }
                    } }),
                React.createElement("div", { style: { padding: '10px 20px 10px 10px', textAlign: 'right' } })),
            this.props.showPaymentButton &&
                React.createElement(core_1.CardActions, { style: { justifyContent: "flex-end" } },
                    React.createElement(core_1.Typography, { variant: "title", style: { marginRight: 10 } }, "Total: $1987.22"),
                    React.createElement(core_1.Button, { variant: "outlined", color: "primary", style: { textTransform: 'none' } }, "Payment"))));
    }
}
BasketInner.defaultProps = {
    basketData: null,
    showPaymentButton: true
};
exports.Basket = basket_context_1.withBasketData(BasketInner);
